
//	This source and byte order compression method apply to GNU General Public License. 
//			Copyright (C) 2008 Jasenko Dzinleski 



//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 


//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			byte order compression
//			written by Dzinleski Jasenko August-September,2008
//
//			to Nada PopStefanova

#include <stdio.h>
#include <string.h>
#include <dirent.h>

#define	fbl 5120

char	in1fn[256]  = "a.txt";
char	out1fn[256] = "c.mar";
char	out2fn[256] = "d.mar";

FILE	*f1,*f2,*f3;

long	b8o,b8e;

bool	br[1000000];int	bri=0;
bool	bs[10000];  int	bsi=0;

long	b1[fbl][2];int	b1i=0;
long	b2[fbl][2];int	b2i=0;

int	ba[16][16][16][16][2];
int	bai=0;

int	da[0xffff];int	dai=0;
char 	fb[fbl];   int	fbi=0;

bool	df=false;

long	npr=0;

long	ifbc=0;
long	ofbc=0;

int pd_18(int i)
{
	npr=0;
	if(br[i]){npr|=1<<17;}++i;
	if(br[i]){npr|=1<<16;}++i;
	if(br[i]){npr|=1<<15;}++i;
	if(br[i]){npr|=1<<14;}++i;
	if(br[i]){npr|=1<<13;}++i;
	if(br[i]){npr|=1<<12;}++i;
	if(br[i]){npr|=1<<11;}++i;
	if(br[i]){npr|=1<<10;}++i;
	if(br[i]){npr|=1<<9; }++i;
	if(br[i]){npr|=1<<8; }++i;
	if(br[i]){npr|=1<<7; }++i;
	if(br[i]){npr|=1<<6; }++i;
	if(br[i]){npr|=1<<5; }++i;
	if(br[i]){npr|=1<<4; }++i;
	if(br[i]){npr|=1<<3; }++i;
	if(br[i]){npr|=1<<2; }++i;
	if(br[i]){npr|=1<<1; }++i;
	if(br[i]){npr|=1<<0; };

	return(i);
}

int pd_34(int i)
{	
	npr=0;
	
	if(!br[i]&&!br[1+i])
	{
		++i;++i;
		if(br[i])
		{
			npr=0;
			npr|=1<<4;
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}else{
			npr=0;
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}
	}else{
		if(!br[i]&&br[1+i])
		{
			++i;
			npr=0;
			npr|=1<<5;
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}else{
			if(br[i]&&!br[1+i])
			{
				++i;
				npr=0;
				npr|=1<<6;
				++i;if(br[i]){npr|=1<<5;}
				++i;if(br[i]){npr|=1<<4;}
				++i;if(br[i]){npr|=1<<3;}
				++i;if(br[i]){npr|=1<<2;}
				++i;if(br[i]){npr|=1<<1;}
				++i;if(br[i]){npr|=1<<0;}
			}else{
				if(br[i]&&br[1+i])
				{
					++i;
					npr=0;
					npr|=1<<7;
					++i;if(br[i]){npr|=1<<6;}
					++i;if(br[i]){npr|=1<<5;}
					++i;if(br[i]){npr|=1<<4;}
					++i;if(br[i]){npr|=1<<3;}
					++i;if(br[i]){npr|=1<<2;}
					++i;if(br[i]){npr|=1<<1;}
					++i;if(br[i]){npr|=1<<0;}
				}
			}
		}
	}

	return(i);
}

int pd_35(int i)
{	
	npr=0;
	
	if(!br[i]&&!br[1+i])
	{
		++i;++i;
		if(br[i])
		{
			npr=0;
			npr|=1<<5;
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}else{
			npr=0;
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}
	}else{
		if(!br[i]&&br[1+i])
		{
			++i;
			npr=0;
			npr|=1<<6;
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}else{
			if(br[i]&&!br[1+i])
			{
				++i;
				npr=0;
				npr|=1<<7;
				++i;if(br[i]){npr|=1<<6;}
				++i;if(br[i]){npr|=1<<5;}
				++i;if(br[i]){npr|=1<<4;}
				++i;if(br[i]){npr|=1<<3;}
				++i;if(br[i]){npr|=1<<2;}
				++i;if(br[i]){npr|=1<<1;}
				++i;if(br[i]){npr|=1<<0;}
			}else{
				if(br[i]&&br[1+i])
				{
					++i;
					npr=0;
					npr|=1<<8;
					++i;if(br[i]){npr|=1<<7;}
					++i;if(br[i]){npr|=1<<6;}
					++i;if(br[i]){npr|=1<<5;}
					++i;if(br[i]){npr|=1<<4;}
					++i;if(br[i]){npr|=1<<3;}
					++i;if(br[i]){npr|=1<<2;}
					++i;if(br[i]){npr|=1<<1;}
					++i;if(br[i]){npr|=1<<0;}
				}
			}
		}
	}

	return(i);
}

int pd_36(int i)
{	
	npr=0;
	
	if(!br[i]&&!br[1+i])
	{
		++i;++i;
		if(br[i])
		{
			npr=0;
			npr|=1<<6;
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}else{
			npr=0;
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}
	}else{
		if(!br[i]&&br[1+i])
		{
			++i;
			npr=0;
			npr|=1<<7;
			++i;if(br[i]){npr|=1<<6;}
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}else{
			if(br[i]&&!br[1+i])
			{
				++i;
				npr=0;
				npr|=1<<8;
				++i;if(br[i]){npr|=1<<7;}
				++i;if(br[i]){npr|=1<<6;}
				++i;if(br[i]){npr|=1<<5;}
				++i;if(br[i]){npr|=1<<4;}
				++i;if(br[i]){npr|=1<<3;}
				++i;if(br[i]){npr|=1<<2;}
				++i;if(br[i]){npr|=1<<1;}
				++i;if(br[i]){npr|=1<<0;}
			}else{
				if(br[i]&&br[1+i])
				{
					++i;
					npr=0;
					npr|=1<<9;
					++i;if(br[i]){npr|=1<<8;}
					++i;if(br[i]){npr|=1<<7;}
					++i;if(br[i]){npr|=1<<6;}
					++i;if(br[i]){npr|=1<<5;}
					++i;if(br[i]){npr|=1<<4;}
					++i;if(br[i]){npr|=1<<3;}
					++i;if(br[i]){npr|=1<<2;}
					++i;if(br[i]){npr|=1<<1;}
					++i;if(br[i]){npr|=1<<0;}
				}
			}
		}
	}

	return(i);
}

int pd_37(int i)
{	
	npr=0;
	
	if(!br[i]&&!br[1+i])
	{
		++i;++i;
		if(br[i])
		{
			npr=0;
			npr|=1<<7;
			++i;if(br[i]){npr|=1<<6;}
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}else{
			npr=0;
			++i;if(br[i]){npr|=1<<6;}
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}
	}else{
		if(!br[i]&&br[1+i])
		{
			++i;
			npr=0;
			npr|=1<<8;
			++i;if(br[i]){npr|=1<<7;}
			++i;if(br[i]){npr|=1<<6;}
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}else{
			if(br[i]&&!br[1+i])
			{
				++i;
				npr=0;
				npr|=1<<9;
				++i;if(br[i]){npr|=1<<8;}
				++i;if(br[i]){npr|=1<<7;}
				++i;if(br[i]){npr|=1<<6;}
				++i;if(br[i]){npr|=1<<5;}
				++i;if(br[i]){npr|=1<<4;}
				++i;if(br[i]){npr|=1<<3;}
				++i;if(br[i]){npr|=1<<2;}
				++i;if(br[i]){npr|=1<<1;}
				++i;if(br[i]){npr|=1<<0;}
			}else{
				if(br[i]&&br[1+i])
				{
					++i;
					npr=0;
					npr|=1<<10;
					++i;if(br[i]){npr|=1<<9;}
					++i;if(br[i]){npr|=1<<8;}
					++i;if(br[i]){npr|=1<<7;}
					++i;if(br[i]){npr|=1<<6;}
					++i;if(br[i]){npr|=1<<5;}
					++i;if(br[i]){npr|=1<<4;}
					++i;if(br[i]){npr|=1<<3;}
					++i;if(br[i]){npr|=1<<2;}
					++i;if(br[i]){npr|=1<<1;}
					++i;if(br[i]){npr|=1<<0;}
				}
			}
		}
	}

	return(i);
}

int pd_38(int i)
{	
	npr=0;
	
	if(!br[i]&&!br[1+i])
	{
		++i;++i;
		if(br[i])
		{
			npr=0;
			npr|=1<<8;
			++i;if(br[i]){npr|=1<<7;}
			++i;if(br[i]){npr|=1<<6;}
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}else{
			npr=0;
			++i;if(br[i]){npr|=1<<7;}
			++i;if(br[i]){npr|=1<<6;}
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}
	}else{
		if(!br[i]&&br[1+i])
		{
			++i;
			npr=0;
			npr|=1<<9;
			++i;if(br[i]){npr|=1<<8;}
			++i;if(br[i]){npr|=1<<7;}
			++i;if(br[i]){npr|=1<<6;}
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}else{
			if(br[i]&&!br[1+i])
			{
				++i;
				npr=0;
				npr|=1<<10;
				++i;if(br[i]){npr|=1<<9;}
				++i;if(br[i]){npr|=1<<8;}
				++i;if(br[i]){npr|=1<<7;}
				++i;if(br[i]){npr|=1<<6;}
				++i;if(br[i]){npr|=1<<5;}
				++i;if(br[i]){npr|=1<<4;}
				++i;if(br[i]){npr|=1<<3;}
				++i;if(br[i]){npr|=1<<2;}
				++i;if(br[i]){npr|=1<<1;}
				++i;if(br[i]){npr|=1<<0;}
			}else{
				if(br[i]&&br[1+i])
				{
					++i;
					npr=0;
					npr|=1<<11;
					++i;if(br[i]){npr|=1<<10;}
					++i;if(br[i]){npr|=1<<9;}
					++i;if(br[i]){npr|=1<<8;}
					++i;if(br[i]){npr|=1<<7;}
					++i;if(br[i]){npr|=1<<6;}
					++i;if(br[i]){npr|=1<<5;}
					++i;if(br[i]){npr|=1<<4;}
					++i;if(br[i]){npr|=1<<3;}
					++i;if(br[i]){npr|=1<<2;}
					++i;if(br[i]){npr|=1<<1;}
					++i;if(br[i]){npr|=1<<0;}
				}
			}
		}
	}

	return(i);
}

int pd_39(int i)
{	
	npr=0;
	
	if(!br[i]&&!br[1+i])
	{
		++i;++i;
		if(br[i])
		{
			npr=0;
			npr|=1<<9;
			++i;if(br[i]){npr|=1<<8;}
			++i;if(br[i]){npr|=1<<7;}
			++i;if(br[i]){npr|=1<<6;}
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}else{
			npr=0;
			++i;if(br[i]){npr|=1<<8;}
			++i;if(br[i]){npr|=1<<7;}
			++i;if(br[i]){npr|=1<<6;}
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}
	}else{
		if(!br[i]&&br[1+i])
		{
			++i;
			npr=0;
			npr|=1<<10;
			++i;if(br[i]){npr|=1<<9;}
			++i;if(br[i]){npr|=1<<8;}
			++i;if(br[i]){npr|=1<<7;}
			++i;if(br[i]){npr|=1<<6;}
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}else{
			if(br[i]&&!br[1+i])
			{
				++i;
				npr=0;
				npr|=1<<11;
				++i;if(br[i]){npr|=1<<10;}
				++i;if(br[i]){npr|=1<<9;}
				++i;if(br[i]){npr|=1<<8;}
				++i;if(br[i]){npr|=1<<7;}
				++i;if(br[i]){npr|=1<<6;}
				++i;if(br[i]){npr|=1<<5;}
				++i;if(br[i]){npr|=1<<4;}
				++i;if(br[i]){npr|=1<<3;}
				++i;if(br[i]){npr|=1<<2;}
				++i;if(br[i]){npr|=1<<1;}
				++i;if(br[i]){npr|=1<<0;}
			}else{
				if(br[i]&&br[1+i])
				{
					++i;
					npr=0;
					npr|=1<<12;
					++i;if(br[i]){npr|=1<<11;}
					++i;if(br[i]){npr|=1<<10;}
					++i;if(br[i]){npr|=1<<9;}
					++i;if(br[i]){npr|=1<<8;}
					++i;if(br[i]){npr|=1<<7;}
					++i;if(br[i]){npr|=1<<6;}
					++i;if(br[i]){npr|=1<<5;}
					++i;if(br[i]){npr|=1<<4;}
					++i;if(br[i]){npr|=1<<3;}
					++i;if(br[i]){npr|=1<<2;}
					++i;if(br[i]){npr|=1<<1;}
					++i;if(br[i]){npr|=1<<0;}
				}
			}
		}
	}

	return(i);
}

int pd_310(int i)
{	
	npr=0;
	
	if(!br[i]&&!br[1+i])
	{
		++i;++i;
		if(br[i])
		{
			npr=0;
			npr|=1<<10;
			++i;if(br[i]){npr|=1<<9;}
			++i;if(br[i]){npr|=1<<8;}
			++i;if(br[i]){npr|=1<<7;}
			++i;if(br[i]){npr|=1<<6;}
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}else{
			npr=0;
			++i;if(br[i]){npr|=1<<9;}
			++i;if(br[i]){npr|=1<<8;}
			++i;if(br[i]){npr|=1<<7;}
			++i;if(br[i]){npr|=1<<6;}
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}
	}else{
		if(!br[i]&&br[1+i])
		{
			++i;
			npr=0;
			npr|=1<<11;
			++i;if(br[i]){npr|=1<<10;}
			++i;if(br[i]){npr|=1<<9;}
			++i;if(br[i]){npr|=1<<8;}
			++i;if(br[i]){npr|=1<<7;}
			++i;if(br[i]){npr|=1<<6;}
			++i;if(br[i]){npr|=1<<5;}
			++i;if(br[i]){npr|=1<<4;}
			++i;if(br[i]){npr|=1<<3;}
			++i;if(br[i]){npr|=1<<2;}
			++i;if(br[i]){npr|=1<<1;}
			++i;if(br[i]){npr|=1<<0;}
		}else{
			if(br[i]&&!br[1+i])
			{
				++i;
				npr=0;
				npr|=1<<12;
				++i;if(br[i]){npr|=1<<11;}
				++i;if(br[i]){npr|=1<<10;}
				++i;if(br[i]){npr|=1<<9;}
				++i;if(br[i]){npr|=1<<8;}
				++i;if(br[i]){npr|=1<<7;}
				++i;if(br[i]){npr|=1<<6;}
				++i;if(br[i]){npr|=1<<5;}
				++i;if(br[i]){npr|=1<<4;}
				++i;if(br[i]){npr|=1<<3;}
				++i;if(br[i]){npr|=1<<2;}
				++i;if(br[i]){npr|=1<<1;}
				++i;if(br[i]){npr|=1<<0;}
			}else{
				if(br[i]&&br[1+i])
				{
					++i;
					npr=0;
					npr|=1<<13;
					++i;if(br[i]){npr|=1<<12;}
					++i;if(br[i]){npr|=1<<11;}
					++i;if(br[i]){npr|=1<<10;}
					++i;if(br[i]){npr|=1<<9;}
					++i;if(br[i]){npr|=1<<8;}
					++i;if(br[i]){npr|=1<<7;}
					++i;if(br[i]){npr|=1<<6;}
					++i;if(br[i]){npr|=1<<5;}
					++i;if(br[i]){npr|=1<<4;}
					++i;if(br[i]){npr|=1<<3;}
					++i;if(br[i]){npr|=1<<2;}
					++i;if(br[i]){npr|=1<<1;}
					++i;if(br[i]){npr|=1<<0;}
				}
			}
		}
	}

	return(i);
}

void pd18(int d)
{
	if((((d<< 1)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<< 2)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<< 3)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<< 4)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<< 5)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<< 6)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<< 7)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<< 8)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<< 9)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<<10)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<<11)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<<12)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<<13)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<<14)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<<15)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<<16)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<<17)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	if((((d<<18)>>18)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
}

int pd34(int m)
{
	int	a,b;

	for(b=3;b>=0;--b){if(((m>>(b+4))&0x1)==1){break;}}

	if(b==0)
	{
		br[bri]=false;++bri;
		br[bri]=false;++bri;
		br[bri]=true;++bri;		

		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==1)
	{
		br[bri]=false;++bri;
		br[bri]=true;++bri;

		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==2)
	{
		br[bri]=true;++bri;
		br[bri]=false;++bri;

		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==3)
	{
		br[bri]=true;++bri;
		br[bri]=true;++bri;

		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==-1)
	{
		br[bri]=false;++bri;
		br[bri]=false;++bri;
		br[bri]=false;++bri;

		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}}}}}

	return(b);			
}

int pd35(int m)
{
	int	a,b;

	for(b=3;b>=0;--b){if(((m>>(b+5))&0x1)==1){break;}}

	if(b==0)
	{
		br[bri]=false;++bri;
		br[bri]=false;++bri;
		br[bri]=true;++bri;		

		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==1)
	{
		br[bri]=false;++bri;
		br[bri]=true;++bri;

		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==2)
	{
		br[bri]=true;++bri;
		br[bri]=false;++bri;

		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==3)
	{
		br[bri]=true;++bri;
		br[bri]=true;++bri;

		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==-1)
	{
		br[bri]=false;++bri;
		br[bri]=false;++bri;
		br[bri]=false;++bri;

		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}}}}}

	return(b);			
}

int pd36(int m)
{
	int	a,b;

	for(b=3;b>=0;--b){if(((m>>(b+6))&0x1)==1){break;}}

	if(b==0)
	{
		br[bri]=false;++bri;
		br[bri]=false;++bri;
		br[bri]=true;++bri;		

		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==1)
	{
		br[bri]=false;++bri;
		br[bri]=true;++bri;

		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==2)
	{
		br[bri]=true;++bri;
		br[bri]=false;++bri;

		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==3)
	{
		br[bri]=true;++bri;
		br[bri]=true;++bri;

		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==-1)
	{
		br[bri]=false;++bri;
		br[bri]=false;++bri;
		br[bri]=false;++bri;

		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}}}}}

	return(b);			
}

int pd37(int m)
{
	int	a,b;

	for(b=3;b>=0;--b){if(((m>>(b+7))&0x1)==1){break;}}

	if(b==0)
	{
		br[bri]=false;++bri;
		br[bri]=false;++bri;
		br[bri]=true;++bri;		

		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==1)
	{
		br[bri]=false;++bri;
		br[bri]=true;++bri;

		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==2)
	{
		br[bri]=true;++bri;
		br[bri]=false;++bri;

		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==3)
	{
		br[bri]=true;++bri;
		br[bri]=true;++bri;

		if((((m<< 6)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==-1)
	{
		br[bri]=false;++bri;
		br[bri]=false;++bri;
		br[bri]=false;++bri;

		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}}}}}

	return(b);			
}

int pd38(int m)
{
	int	a,b;

	for(b=3;b>=0;--b){if(((m>>(b+8))&0x1)==1){break;}}

	if(b==0)
	{
		br[bri]=false;++bri;
		br[bri]=false;++bri;
		br[bri]=true;++bri;		

		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==1)
	{
		br[bri]=false;++bri;
		br[bri]=true;++bri;

		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==2)
	{
		br[bri]=true;++bri;
		br[bri]=false;++bri;

		if((((m<< 6)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==3)
	{
		br[bri]=true;++bri;
		br[bri]=true;++bri;

		if((((m<< 5)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 6)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==-1)
	{
		br[bri]=false;++bri;
		br[bri]=false;++bri;
		br[bri]=false;++bri;

		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}}}}}

	return(b);			
}

int pd39(int m)
{
	int	a,b;

	for(b=3;b>=0;--b){if(((m>>(b+9))&0x1)==1){break;}}

	if(b==0)
	{
		br[bri]=false;++bri;
		br[bri]=false;++bri;
		br[bri]=true;++bri;		

		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==1)
	{
		br[bri]=false;++bri;
		br[bri]=true;++bri;

		if((((m<< 6)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==2)
	{
		br[bri]=true;++bri;
		br[bri]=false;++bri;

		if((((m<< 5)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 6)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==3)
	{
		br[bri]=true;++bri;
		br[bri]=true;++bri;

		if((((m<< 4)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 5)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 6)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==-1)
	{
		br[bri]=false;++bri;
		br[bri]=false;++bri;
		br[bri]=false;++bri;

		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}}}}}

	return(b);			
}

int pd310(int m)
{
	int	a,b;

	for(b=3;b>=0;--b){if(((m>>(b+10))&0x1)==1){break;}}

	if(b==0)
	{
		br[bri]=false;++bri;
		br[bri]=false;++bri;
		br[bri]=true;++bri;		

		if((((m<< 6)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==1)
	{
		br[bri]=false;++bri;
		br[bri]=true;++bri;

		if((((m<< 5)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 6)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==2)
	{
		br[bri]=true;++bri;
		br[bri]=false;++bri;

		if((((m<< 4)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 5)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 6)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==3)
	{
		br[bri]=true;++bri;
		br[bri]=true;++bri;

		if((((m<< 3)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 4)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 5)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 6)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}else{
	if(b==-1)
	{
		br[bri]=false;++bri;
		br[bri]=false;++bri;
		br[bri]=false;++bri;

		if((((m<< 6)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 7)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
	}}}}}

	return(b);			
}

int	m_d()
{
	int	fbyte;

	int	fb1_1,fb1_2;

	int	i,j,k,l,m,n;
	int	a,b,c,d,e;
	int	a_b,b_b,c_b,d_b;
	int	a_h,a_l;
	int	fc,fc0,fw,fw0;
	int	fch,fcl;

	f3=fopen(out2fn,"rb");a=getc(f3);b=getc(f3);while(!feof(f3)){da[dai]=(a<<8)|b;++dai;a=getc(f3);b=getc(f3);}fclose(f3);

	for(i=0;i<fbl;++i){fb[i]='\0';}
	f2=fopen(out1fn,"rb");
	fch=getc(f2);fcl=getc(f2);fw0=getc(f2);

	fbyte=getc(f2);
	while(!feof(f2))
	{
		if((((fbyte<< 8)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((fbyte<< 9)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((fbyte<<10)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((fbyte<<11)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((fbyte<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((fbyte<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((fbyte<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
		if((((fbyte<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}

		if(bri>=((fch<<8)|fcl))
		{
			m=0;b=0;
			if(br[b]){m|=1<<3; }++b;
			if(br[b]){m|=1<<2; }++b;
			if(br[b]){m|=1<<1; }++b;
			if(br[b]){m|=1<<0; }++b;

			fc=fc0;	
			for(a=b;a<((fch<<8)|fcl);)
			{
				if(m==4-1) {a=pd_34(a); ++a;a_h=npr;a=pd_34(a); ++a;a_l=npr;}
				if(m==5-1) {a=pd_35(a); ++a;a_h=npr;a=pd_35(a); ++a;a_l=npr;}
				if(m==6-1) {a=pd_36(a); ++a;a_h=npr;a=pd_36(a); ++a;a_l=npr;}
				if(m==7-1) {a=pd_37(a); ++a;a_h=npr;a=pd_37(a); ++a;a_l=npr;}
				if(m==8-1) {a=pd_38(a); ++a;a_h=npr;a=pd_38(a); ++a;a_l=npr;}
				if(m==9-1) {a=pd_39(a); ++a;a_h=npr;a=pd_39(a); ++a;a_l=npr;}
				if(m==10-1){a=pd_310(a);++a;a_h=npr;a=pd_310(a);++a;a_l=npr;}
				if(m==11-1){a=pd_18(a); ++a;a_h=npr;a=pd_18(a); ++a;a_l=npr;}

				b2[b2i][0]=da[a_h];++b2i;b2[b2i][0]=da[a_l];++b2i;
			}

			fw=fw0;fb[fbi]=(char)fw;++fbi;
			for(i=0;i<b2i;++i)
			{
				for(k=0;k<256;++k)
				{
					c=((((b8e&fw)>>1)^((b8e&k)>>1))<<1)|((b8o&fw)^(b8o&k));
					if(c==((b2[i][0]&0xff00)>>8))
					{
						//printf("%c%c ",fw,k);
						fw=k;fb[fbi]=(char)fw;++fbi;break;}
				}
				if(k==256){printf("Error...\n");}
				for(k=0;k<256;++k)
				{
					c=((((b8e&fw)>>1)^((b8e&k)>>1))<<1)|((b8o&fw)^(b8o&k));
					if(c==(b2[i][0]&0x00ff))
					{
						//printf("%c%c ",fw,k);
						fw=k;fb[fbi]=(char)fw;++fbi;break;}
				}
				if(k==256){printf("Error...\n");}
			}
			for(i=0;i<fbi;++i){printf("%c",fb[i]);}for(i=0;i<fbl;++i){fb[i]='\0';}

			bri=0;fbi=0;b2i=0;
			fch=getc(f2);fcl=getc(f2);fw0=getc(f2);
		}
		fbyte=getc(f2);
	}
	fclose(f2);

	return(0);
}

int	m_c()
{
	int	fbyte;

	int	fb1_1,fb1_2;

	int	i,j,k,l,m,n;
	int	a,b,c,d,e;
	int	a_b,b_b,c_b,d_b;
	int	a_h,a_l;
	int	fc,fc0,fw,fw0;

	for(i=0;i<0xffff;++i){da[i]=-1;}
	for(i=0;i<fbl;++i){fb[i]='\0';}
	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l){ba[i][j][k][l][0]=-1;ba[i][j][k][l][1]=0;}}}}

	f2=fopen(out1fn,"wb");
	f1=fopen(in1fn,"rb");

	b=1;
	fb1_1=getc(f1);++ifbc;fw=fb1_1;fw0=fw;
	while(!feof(f1))
	{
		fb1_2=getc(f1);++ifbc;
		c=((((b8e&fb1_1)>>1)^((b8e&fb1_2)>>1))<<1)|((b8o&fb1_1)^(b8o&fb1_2));
		b1[b1i][0]=c;++b1i;	
		fb1_1=fb1_2;
		++b;

		if(b==fbl||feof(f1))
		{
			b=0;for(i=0;i<b1i-1;i+=2){b1[b][1]=((b1[i][0]&0x00ff)<<8)|(b1[1+i][0]&0x00ff);++b;}b1i=b;fc=b1[0][1];fc0=fc;

			for(i=0;i<b1i;++i)
			{
					a_b=(b1[i][1]&0xf000)>>12;
					b_b=(b1[i][1]&0x0f00)>>8;
					c_b=(b1[i][1]&0x00f0)>>4;
					d_b=(b1[i][1]&0x000f)>>0;
					if(ba[a_b][b_b][c_b][d_b][0]==-1){ba[a_b][b_b][c_b][d_b][1]=1;ba[a_b][b_b][c_b][d_b][0]=bai;++bai;}else{++ba[a_b][b_b][c_b][d_b][1];}
			}

			for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l){
				if(ba[i][j][k][l][0]!=-1&&da[ba[i][j][k][l][0]]==-1){da[ba[i][j][k][l][0]]=(i<<12)|(j<<8)|(k<<4)|(l<<0);++dai;}
			}}}}

			b=0;for(i=0;i<b1i;i+=2){b1[b][0]=((b1[i][1]&0xffff)<<16)|(b1[1+i][1]&0xffff);++b;}b1i=b;
			
			a=0;d=0;
			for(i=0;i<b1i;)
			{
				if(a==0)
				{
					a_b=(((b1[i][0]&0xffff0000)>>16)&0xf000)>>12;
					b_b=(((b1[i][0]&0xffff0000)>>16)&0x0f00)>>8;
					c_b=(((b1[i][0]&0xffff0000)>>16)&0x00f0)>>4;
					d_b=(((b1[i][0]&0xffff0000)>>16)&0x000f)>>0;
					if(ba[a_b][b_b][c_b][d_b][0]==-1){printf("Index Error...\n");}else{k=ba[a_b][b_b][c_b][d_b][0];}

				}else{
					a_b=((b1[i][0]&0x0000ffff)&0xf000)>>12;
					b_b=((b1[i][0]&0x0000ffff)&0x0f00)>>8;
					c_b=((b1[i][0]&0x0000ffff)&0x00f0)>>4;
					d_b=((b1[i][0]&0x0000ffff)&0x000f)>>0;
					if(ba[a_b][b_b][c_b][d_b][0]==-1){printf("Index Error...\n");}else{k=ba[a_b][b_b][c_b][d_b][0];}
				}
				if(d==0){d=k;}else{if(d<k){d=k;}}
				if(a==0){a=1;}else{a=0;++i;}
			}

			for(b=15;b>4+3;--b){if(((d>>b)&0x1)==1){m=b;break;}}

			if(m>4+3)
			{			
				if(m>5+3)
				{
					if(m>6+3)
					{
						if(m>7+3)
						{
							if(m>8+3)
							{
								if(m>9+3)
								{
									if(m>10+3)
									{
										m=11-1;
										if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
										if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
										if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
										if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
									}else{
										m=10-1;
										if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
										if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
										if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
										if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
									}
								}else{
									m=9-1;
									if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
									if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
									if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
									if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
								}
							}else{
								m=8-1;
								if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
								if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
								if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
								if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
							}
						}else{
							m=7-1;
							if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
							if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
							if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
							if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
						}
					}else{
						m=6-1;
						if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
						if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
						if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
						if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
					}
				}else{
					m=5-1;
					if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
					if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
					if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
					if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
				}
			}else{
				m=4-1;
				if((((m<<12)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
				if((((m<<13)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
				if((((m<<14)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
				if((((m<<15)>>15)&0x1)==1){br[bri]=true;++bri;}else{br[bri]=false;++bri;}
			}

			a=0;
			for(i=0;i<b1i;)
			{
				if(a==0)
				{
					a_b=(((b1[i][0]&0xffff0000)>>16)&0xf000)>>12;
					b_b=(((b1[i][0]&0xffff0000)>>16)&0x0f00)>>8;
					c_b=(((b1[i][0]&0xffff0000)>>16)&0x00f0)>>4;
					d_b=(((b1[i][0]&0xffff0000)>>16)&0x000f)>>0;
					if(ba[a_b][b_b][c_b][d_b][0]==-1){printf("Index Error...\n");}else{k=ba[a_b][b_b][c_b][d_b][0];}

				}else{
					a_b=((b1[i][0]&0x0000ffff)&0xf000)>>12;
					b_b=((b1[i][0]&0x0000ffff)&0x0f00)>>8;
					c_b=((b1[i][0]&0x0000ffff)&0x00f0)>>4;
					d_b=((b1[i][0]&0x0000ffff)&0x000f)>>0;
					if(ba[a_b][b_b][c_b][d_b][0]==-1){printf("Index Error...\n");}else{k=ba[a_b][b_b][c_b][d_b][0];}
				}
				if(a==0){a_h=k;}else{a_l=k;}

				if(a==0){a=1;}else{

					a=0;++i;

					if(m>4-1)
					{			
						if(m>5-1)
						{
							if(m>6-1)
							{
								if(m>7-1)
								{
									if(m>8-1)
									{
										if(m>9-1)
										{
											if(m>10-1)
											{
												pd18(a_h);pd18(a_l);
											}else{
												pd310(a_h);pd310(a_l);
											}
										}else{
											pd39(a_h);pd39(a_l);
										}
									}else{
										pd38(a_h);pd38(a_l);
									}
								}else{
									pd37(a_h);pd37(a_l);
								}
							}else{
								pd36(a_h);pd36(a_l);
							}
						}else{
							pd35(a_h);pd35(a_l);
						}
					}else{
						pd34(a_h);pd34(a_l);
					}
				}
			}

			if((((bri<< 0)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<< 1)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<< 2)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<< 3)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<< 4)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<< 5)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<< 6)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<< 7)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<< 8)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<< 9)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<<10)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<<11)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<<12)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<<13)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<<14)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((bri<<15)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
		
			if((((fw0<< 8)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((fw0<< 9)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((fw0<<10)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((fw0<<11)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((fw0<<12)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((fw0<<13)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((fw0<<14)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}
			if((((fw0<<15)>>15)&0x1)==1){bs[bsi]=true;++bsi;}else{bs[bsi]=false;++bsi;}

			for (i=0;i<bsi;)
			{
				k=0;
				if(bs[i]){k|=1<<7;}if(i==bsi-1){fprintf(f2,"%c",k);break;}
				++i;
				if(bs[i]){k|=1<<6;}if(i==bsi-1){fprintf(f2,"%c",k);break;}
				++i;
				if(bs[i]){k|=1<<5;}if(i==bsi-1){fprintf(f2,"%c",k);break;}
				++i;
				if(bs[i]){k|=1<<4;}if(i==bsi-1){fprintf(f2,"%c",k);break;}
				++i;
				if(bs[i]){k|=1<<3;}if(i==bsi-1){fprintf(f2,"%c",k);break;}
				++i;
				if(bs[i]){k|=1<<2;}if(i==bsi-1){fprintf(f2,"%c",k);break;}
				++i;
				if(bs[i]){k|=1<<1;}if(i==bsi-1){fprintf(f2,"%c",k);break;}
				++i;
				if(bs[i]){k|=1<<0;}
				++i;
				fprintf(f2,"%c",k);
			}ofbc+=bsi/8;

			for (i=0;i<bri;)
			{
				k=0;
				if(br[i]){k|=1<<7;}if(i==bri-1){fprintf(f2,"%c",k);break;}
				++i;
				if(br[i]){k|=1<<6;}if(i==bri-1){fprintf(f2,"%c",k);break;}
				++i;
				if(br[i]){k|=1<<5;}if(i==bri-1){fprintf(f2,"%c",k);break;}
				++i;
				if(br[i]){k|=1<<4;}if(i==bri-1){fprintf(f2,"%c",k);break;}
				++i;
				if(br[i]){k|=1<<3;}if(i==bri-1){fprintf(f2,"%c",k);break;}
				++i;
				if(br[i]){k|=1<<2;}if(i==bri-1){fprintf(f2,"%c",k);break;}
				++i;
				if(br[i]){k|=1<<1;}if(i==bri-1){fprintf(f2,"%c",k);break;}
				++i;
				if(br[i]){k|=1<<0;}
				++i;
				fprintf(f2,"%c",k);
			}ofbc+=bri/8;
/*			
			m=0;b=0;
			if(br[b]){m|=1<<3; }++b;
			if(br[b]){m|=1<<2; }++b;
			if(br[b]){m|=1<<1; }++b;
			if(br[b]){m|=1<<0; }++b;

			fc=fc0;	
			for(a=b;a<bri;)
			{
				if(m==4-1) {a=pd_34(a); ++a;a_h=npr;a=pd_34(a); ++a;a_l=npr;}
				if(m==5-1) {a=pd_35(a); ++a;a_h=npr;a=pd_35(a); ++a;a_l=npr;}
				if(m==6-1) {a=pd_36(a); ++a;a_h=npr;a=pd_36(a); ++a;a_l=npr;}
				if(m==7-1) {a=pd_37(a); ++a;a_h=npr;a=pd_37(a); ++a;a_l=npr;}
				if(m==8-1) {a=pd_38(a); ++a;a_h=npr;a=pd_38(a); ++a;a_l=npr;}
				if(m==9-1) {a=pd_39(a); ++a;a_h=npr;a=pd_39(a); ++a;a_l=npr;}
				if(m==10-1){a=pd_310(a);++a;a_h=npr;a=pd_310(a);++a;a_l=npr;}
				if(m==11-1){a=pd_18(a); ++a;a_h=npr;a=pd_18(a); ++a;a_l=npr;}

				b2[b2i][0]=da[a_h];++b2i;b2[b2i][0]=da[a_l];++b2i;
			}

			fw=fw0;fb[fbi]=(char)fw;++fbi;
			for(i=0;i<b2i;++i)
			{
				for(k=0;k<256;++k)
				{
					c=((((b8e&fw)>>1)^((b8e&k)>>1))<<1)|((b8o&fw)^(b8o&k));
					if(c==((b2[i][0]&0xff00)>>8))
					{
						//printf("%c%c ",fw,k);
						fw=k;fb[fbi]=(char)fw;++fbi;break;}
				}
				if(k==256){printf("Error...\n");}
				for(k=0;k<256;++k)
				{
					c=((((b8e&fw)>>1)^((b8e&k)>>1))<<1)|((b8o&fw)^(b8o&k));
					if(c==(b2[i][0]&0x00ff))
					{
						//printf("%c%c ",fw,k);
						fw=k;fb[fbi]=(char)fw;++fbi;break;}
				}
				if(k==256){printf("Error...\n");}
			}
			for(i=0;i<fbi;++i){printf("%c",fb[i]);}for(i=0;i<fbl;++i){fb[i]='\0';}
*/
			fbi=0;b2i=0;b1i=0;bri=0;bsi=0;b=1;
			fb1_1=getc(f1);++ifbc;fw=fb1_1;fw0=fw;
		}
	}
	fclose(f1);
	fclose(f2);

	f3=fopen(out2fn,"wb");for(i=0;i<dai;++i){fprintf(f3,"%c",((da[i]&0xff00)>>8));++ofbc;fprintf(f3,"%c",(da[i]&0x00ff));++ofbc;}fclose(f3);

	//printf("%d\n",dai);

	printf("\n%d\nOk\n",((100*ofbc)/ifbc));

	return(0);
}

int main(int argc,char *argv[])
{
	int	i,j,k,l,m;
	char	fn[256];

	b8o=0;
	b8o|=1<<0;
	b8o|=1<<2;
	b8o|=1<<4;
	b8o|=1<<6;

	b8e=0;
	b8e|=1<<1;
	b8e|=1<<3;
	b8e|=1<<5;
	b8e|=1<<7;

	if(argv[1]!=NULL)
	{
  		strcpy(in1fn,argv[1]);
		if(in1fn[0]=='-')
		{
			if(in1fn[1]=='l'||in1fn[1]=='e')
			{
				printf("\nByte Order Compression\n");
				printf("written by Dzinleski Jasenko September,2008\n");
				printf("\nOS Win32 VRM 1.1.0\n\n");
				printf("\n");
				printf("\tThis source and byte order compression method apply to GNU General Public License.\n");
				printf("\t		Copyright (C) 2008 Jasenko Dzinleski \n");
				printf("\n");
				printf("\t	This program is free software; you can redistribute it\n");
				printf("\tand/or modify it under the terms of the GNU General Public License as\n");
				printf("\tpublished by the Free Software Foundation; either version 2 of the\n");
				printf("\tLicense, or (at your option) any later version.\n");
				printf("\n");
				printf("\tThis program is distributed in the hope that it will be useful, but\n");
				printf("\tWITHOUT ANY WARRANTY; without even the implied warranty of\n");
				printf("\tMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n");
				printf("\tGeneral Public License for more details.\n");
				printf("\n");
				printf("\tYou should have received a copy of the GNU General Public License along\n");
				printf("\twith this program; if not, write to the Free Software Foundation, Inc.,\n");
				printf("\t51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.\n");
				printf("\n");
				return(0);
			}else{
				if(in1fn[1]=='h')
				{
					printf("\nByte Order Compression\n");
					printf("written by Dzinleski Jasenko September,2008\n");
					printf("\nOS Win32 VRM 1.1.0\n\n");
					printf("\n");
					printf("e1173 <filename>\n");
					printf("\n");
					return(0);
				}else{
					if(in1fn[1]=='d')
					{
						printf("\nByte Order Compression\n");
						printf("written by Dzinleski Jasenko September,2008\n");
						printf("\nOS Win32 VRM 1.1.0\n");
						printf("\n");

						if(argv[2]!=NULL)
						{

							for(j=0;j<256;++j){fn[j]='\0';}
							strcpy(fn,argv[2]);
							for(l=0;fn[l]!='.';++l){}for(m=0;out1fn[m]!='.';++m){}
							fn[l]='_';++l;
							for(k=l;k<l+m;++k){fn[k]=out1fn[k-l];}
							fn[k]='.';fn[++k]='m';fn[++k]='a';fn[++k]='r';
							//printf("%s\n",fn);
							for(j=0;j<256;++j){out1fn[j]='\0';}
							for(k=0;k<strlen(fn);++k){out1fn[k]=fn[k];}
	
							for(j=0;j<256;++j){fn[j]='\0';}
							strcpy(fn,argv[2]);
							for(l=0;fn[l]!='.';++l){}for(m=0;out2fn[m]!='.';++m){}
							fn[l]='_';++l;
							for(k=l;k<l+m;++k){fn[k]=out2fn[k-l];}
							fn[k]='.';fn[++k]='m';fn[++k]='a';fn[++k]='r';
							//printf("%s\n",fn);
							for(j=0;j<256;++j){out2fn[j]='\0';}
							for(k=0;k<strlen(fn);++k){out2fn[k]=fn[k];}

							f2=fopen(out1fn,"rb");if(f2==NULL){printf("No input file...\n");return(0);}else{fclose(f2);}
							f3=fopen(out2fn,"rb");if(f3==NULL){printf("No input file...\n");return(0);}else{fclose(f3);}

							m_d();

							return(0);

						}else{printf("No input file...\n");return(0);}
					}else{
						if(in1fn[1]=='c')
						{
							printf("\nByte Order Compression\n");
							printf("written by Dzinleski Jasenko September,2008\n");
							printf("\nOS Win32 VRM 1.1.0\n");
							printf("\n");
							if(argv[2]!=NULL)
							{
								strcpy(in1fn,argv[2]);
								f1=fopen(in1fn,"rb");if(f1==NULL){printf("No input file...\n");return(0);}else{fclose(f1);}

								for(j=0;j<256;++j){fn[j]='\0';}
								strcpy(fn,argv[2]);
								for(l=0;fn[l]!='.';++l){}for(m=0;out1fn[m]!='.';++m){}
								fn[l]='_';++l;
								for(k=l;k<l+m;++k){fn[k]=out1fn[k-l];}
								fn[k]='.';fn[++k]='m';fn[++k]='a';fn[++k]='r';
								//printf("%s\n",fn);
								for(j=0;j<256;++j){out1fn[j]='\0';}
								for(k=0;k<strlen(fn);++k){out1fn[k]=fn[k];}

								for(j=0;j<256;++j){fn[j]='\0';}
								strcpy(fn,argv[2]);
								for(l=0;fn[l]!='.';++l){}for(m=0;out2fn[m]!='.';++m){}
								fn[l]='_';++l;
								for(k=l;k<l+m;++k){fn[k]=out2fn[k-l];}
								fn[k]='.';fn[++k]='m';fn[++k]='a';fn[++k]='r';
								//printf("%s\n",fn);
								for(j=0;j<256;++j){out2fn[j]='\0';}
								for(k=0;k<strlen(fn);++k){out2fn[k]=fn[k];}

								m_c();

							}else{printf("No input file...\n");return(0);}
						}else{
							return(0);
						}
					}
				}
			}
		}else{f1=fopen(in1fn,"rb");if(f1==NULL){printf("No input file...\n");return(0);}else{fclose(f1);}}

	}else{
		printf("\nByte Order Compression\n");
		printf("written by Dzinleski Jasenko September,2008\n");
		printf("\nOS Win32 VRM 1.1.0\n");
		return(0);
	}

	return(0);
}	